moModule = {};
source(MultiOverlayV3.modDir.."scripte/module/fillTypes/moFillTypes.lua");
source(MultiOverlayV3.modDir.."scripte/module/greatDemand/moGreatDemand.lua");
source(MultiOverlayV3.modDir.."scripte/module/storages/moStorages.lua");
source(MultiOverlayV3.modDir.."scripte/module/amount/moAmount.lua");
source(MultiOverlayV3.modDir.."scripte/module/sellingStations/moSellingStations.lua");
source(MultiOverlayV3.modDir.."scripte/module/buyingStations/moBuyingStations.lua");
source(MultiOverlayV3.modDir.."scripte/module/animals/moAnimals.lua");
source(MultiOverlayV3.modDir.."scripte/module/items/moItems.lua");
source(MultiOverlayV3.modDir.."scripte/module/beehivehouses/moBeehivehouses.lua");
source(MultiOverlayV3.modDir.."scripte/module/greenhouses/moGreenhouses.lua");
source(MultiOverlayV3.modDir.."scripte/module/solarcollectoren/moSolarcollectoren.lua");
source(MultiOverlayV3.modDir.."scripte/module/windturbinen/moWindturbinen.lua");
source(MultiOverlayV3.modDir.."scripte/module/heatingplants/moHeatingplants.lua");
source(MultiOverlayV3.modDir.."scripte/module/bgas/moBGAs.lua");
source(MultiOverlayV3.modDir.."scripte/module/missions/moMissions.lua");
source(MultiOverlayV3.modDir.."scripte/module/bunkersilos/moBunkerSilos.lua");
source(MultiOverlayV3.modDir.."scripte/module/feedmixers/moFeedMixers.lua");
source(MultiOverlayV3.modDir.."scripte/module/gcfactorys/moGC_Factorys.lua");

moModule.active = {amount={isRunning=false, last=0}, gcfactorys={isRunning=false, last=0}, feedmixers={isRunning=false, last=0}, bunkersilos={isRunning=false, last=0}, missions={isRunning=false, last=0}, bgas={isRunning=false, last=0}, solarcollectoren={isRunning=false, last=0}, heatingplants={isRunning=false, last=0}, windturbinen={isRunning=false, last=0}, beehivehouses={isRunning=false, last=0}, greenhouses={isRunning=false, last=0}, items={isRunning=false, last=0}, animals={isRunning=false, last=0}, fillTypes={isRunning=false, last=0}, greatDemand={isRunning=false, last=0}, storages={isRunning=false, last=0}, sellingStationsSimple={isRunning=false, last=0}, buyingStationsSimple={isRunning=false, last=0}}; --insert new active module or ... check your module with ....isRunning
moModule.values = {maxTimer=120, languageXml=false, txtPriceColor="white", txtNoPriceColor="darkGray", txtNoAmountColor="darkGray", txtAmountColor="yellow", txtFillTypesColor="yellow", txtGreatDemandColor="ls15", txtActiveColor="ls15", txtTitleColor="khaki", txtColor="white", txtBold=false};
moModule.time = {delay=1, dt=0, min=0}; --1 min
moModule.guiMenue = {"moFillTypes", "moAmount", "moAnimals", "moBGAs", "moBunkerSilos", "moByingStations", "moGC_Factorys", "moFeedMixers", "moGreatDemand", "moGreenhouses", "moItems", "moMissions", "moSellingStations", "moStorages", "Text Color", "Prozent Color"};
function moModule:isRunning()	
	for name, modul in pairs (moModule.active) do
		if modul.isRunning then
			if modul.last < moModule.time.min then
				modul.isRunning=false;modul.last=0;				
			end;
		end;
	end;
end;

function moModule:update(dt)	
	moModule.time.min = tonumber(getDate("%M"));	
	if moFillTypes.update ~= nil then moFillTypes:update(dt);end;
	if moGreatDemand.update ~= nil then moGreatDemand:update(dt);end;
	if moStorages.update ~= nil then moStorages:update(dt);end;
	if moAmount.update ~= nil then moAmount:update(dt);end;
	if moSellingStations.update ~= nil then moSellingStations:update(dt);end;
	if moBuyingStations.update ~= nil then moBuyingStations:update(dt);end;
	if moAnimals.update ~= nil then moAnimals:update(dt);end;
	if moItems.update ~= nil then moItems:update(dt);end;
	if moHeatingplants.update ~= nil then moHeatingplants:update(dt);end;
	if moGreenhouses.update ~= nil then moGreenhouses:update(dt);end;
	if moSolarcollectoren.update ~= nil then moSolarcollectoren:update(dt);end;
	if moBeehivehouses.update ~= nil then moBeehivehouses:update(dt);end;
	if moWindturbinen.update ~= nil then moWindturbinen:update(dt);end;
	if moBGAs.update ~= nil then moBGAs:update(dt);end;
	if moMissions.update ~= nil then moMissions:update(dt);end;
	if moBunkerSilos.update ~= nil then moBunkerSilos:update(dt);end;
	if moFeedMixers.update ~= nil then moFeedMixers:update(dt);end;
	if moGC_Factorys.update ~= nil then moGC_Factorys:update(dt);end;
end;

function moModule:loadConfigs(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moFillTypesConfig.loadXml ~= nil then moFillTypesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moGreatDemandConfig.loadXml ~= nil then moGreatDemandConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moStoragesConfig.loadXml ~= nil then moStoragesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moAmountConfig.loadXml ~= nil then moAmountConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moSellingStationsConfig.loadXml ~= nil then moSellingStationsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moBuyingStationsConfig.loadXml ~= nil then moBuyingStationsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moAnimalsConfig.loadXml ~= nil then moAnimalsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moItemsConfig.loadXml ~= nil then moItemsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moHeatingplantsConfig.loadXml ~= nil then moHeatingplantsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moGreenhousesConfig.loadXml ~= nil then moGreenhousesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moSolarcollectorenConfig.loadXml ~= nil then moSolarcollectorenConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moBeehivehousesConfig.loadXml ~= nil then moBeehivehousesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moWindturbinenConfig.loadXml ~= nil then moWindturbinenConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moBGAsConfig.loadXml ~= nil then moBGAsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moMissionsConfig.loadXml ~= nil then moMissionsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moBunkerSilosConfig.loadXml ~= nil then moBunkerSilosConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moFeedMixersConfig.loadXml ~= nil then moFeedMixersConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	if moGC_FactorysConfig.loadXml ~= nil then moGC_FactorysConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);end;
	moModule:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex);
end;

function moModule:saveConfigs(self, Xml, xmlNameTag)
	if moFillTypesConfig.saveXml ~= nil then moFillTypesConfig:saveXml(self, Xml, xmlNameTag);end;
	if moGreatDemandConfig.saveXml ~= nil then moGreatDemandConfig:saveXml(self, Xml, xmlNameTag);end;
	if moStoragesConfig.saveXml ~= nil then moStoragesConfig:saveXml(self, Xml, xmlNameTag);end;
	if moAmountConfig.saveXml ~= nil then moAmountConfig:saveXml(self, Xml, xmlNameTag);end;
	if moSellingStationsConfig.saveXml ~= nil then moSellingStationsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moBuyingStationsConfig.saveXml ~= nil then moBuyingStationsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moAnimalsConfig.saveXml ~= nil then moAnimalsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moItemsConfig.saveXml ~= nil then moItemsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moHeatingplantsConfig.saveXml ~= nil then moHeatingplantsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moGreenhousesConfig.saveXml ~= nil then moGreenhousesConfig:saveXml(self, Xml, xmlNameTag);end;
	if moSolarcollectorenConfig.saveXml ~= nil then moSolarcollectorenConfig:saveXml(self, Xml, xmlNameTag);end;
	if moBeehivehousesConfig.saveXml ~= nil then moBeehivehousesConfig:saveXml(self, Xml, xmlNameTag);end;
	if moWindturbinenConfig.saveXml ~= nil then moWindturbinenConfig:saveXml(self, Xml, xmlNameTag);end;
	if moBGAsConfig.saveXml ~= nil then moBGAsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moMissionsConfig.saveXml ~= nil then moMissionsConfig:saveXml(self, Xml, xmlNameTag);end;
	if moBunkerSilosConfig.saveXml ~= nil then moBunkerSilosConfig:saveXml(self, Xml, xmlNameTag);end;
	if moFeedMixersConfig.saveXml ~= nil then moFeedMixersConfig:saveXml(self, Xml, xmlNameTag);end;
	if moGC_FactorysConfig.saveXml ~= nil then moGC_FactorysConfig:saveXml(self, Xml, xmlNameTag);end;
	moModule:saveXml(self, Xml, xmlNameTag);
end;

function moModule:onStartMission(update)	
	moModule:generateCmd(update);
	moModule:loadObjects();	
	if moFillTypesConfig.onStartMission ~= nil then moFillTypesConfig:onStartMission();end;
	if moGreatDemandConfig.onStartMission ~= nil then moGreatDemandConfig:onStartMission();end;
	if moStoragesConfig.onStartMission ~= nil then moStoragesConfig:onStartMission();end;
	if moAmountConfig.onStartMission ~= nil then moAmountConfig:onStartMission();end;
	if moSellingStationsConfig.onStartMission ~= nil then moSellingStationsConfig:onStartMission();end;
	if moBuyingStationsConfig.onStartMission ~= nil then moBuyingStationsConfig:onStartMission();end;
	if moAnimalsConfig.onStartMission ~= nil then moAnimalsConfig:onStartMission();end;
	if moItemsConfig.onStartMission ~= nil then moItemsConfig:onStartMission();end;	
	if moHeatingplantsConfig.onStartMission ~= nil then moHeatingplantsConfig:onStartMission();end;
	if moGreenhousesConfig.onStartMission ~= nil then moGreenhousesConfig:onStartMission();end;
	if moSolarcollectorenConfig.onStartMission ~= nil then moSolarcollectorenConfig:onStartMission();end;
	if moBeehivehousesConfig.onStartMission ~= nil then moBeehivehousesConfig:onStartMission();end;
	if moWindturbinenConfig.onStartMission ~= nil then moWindturbinenConfig:onStartMission();end;
	if moBGAsConfig.onStartMission ~= nil then moBGAsConfig:onStartMission();end;
	if moMissionsConfig.onStartMission ~= nil then moMissionsConfig:onStartMission();end;
	if moBunkerSilosConfig.onStartMission ~= nil then moBunkerSilosConfig:onStartMission();end;
	if moFeedMixersConfig.onStartMission ~= nil then moFeedMixersConfig:onStartMission();end;
	if moGC_FactorysConfig.onStartMission ~= nil then moGC_FactorysConfig:onStartMission();end;
	moModule:slotOutputCmd(update)
	if MultiOverlayV3.timers["activeModule"] == nil then 
		moSetGetExtras:addTimer( {delay=10, name="activeModule", action=moModule.isRunning} );
		for name, modul in pairs (moModule.active) do
			modul.isRunning=true;modul.last=moModule.time.min+moModule.time.delay;		
		end;
	end;	
end;

function moModule.updateByPlayer()
	if MultiOverlayV3.timers["updateModuleCooldown"] == nil then 
		moSetGetExtras:addTimer( {delay=10, name="updateModuleCooldown", repeatable=1, action=nil} ); --cooldown Timer
		moModule:onStartMission(true);
	else
		g_currentMission:showBlinkingWarning("Wait 10 sec -Cooldown Active-", 2000)
	end;
end;

function moModule:slotOutputCmd(update)
	function setSlotSortCmdTable()
		local mohSLOTs = moSetGetMohSLOT:getSLOTs();
		for slot=1, #mohSLOTs do
			local whichSubSLOT = mohSLOTs[slot][1];
			moSetGetOverlays.slot[whichSubSLOT].setting.sortNames = {};moSetGetOverlays.slot[whichSubSLOT].setting.sortInt = 1;moSetGetOverlays.slot[whichSubSLOT].setting.sortBy = "All";
		end;		
		function isAlreadyExits(whichSubSLOT, sortBy)
			for a=1, #moSetGetOverlays.slot[whichSubSLOT].setting.sortNames do
				if moSetGetOverlays.slot[whichSubSLOT].setting.sortNames[a] == sortBy then return true;end;
			end;
			return false;
		end;
		for cmdTable=1, #MultiOverlayV3.cmdTable do
			for cmd=1, #MultiOverlayV3.cmdTable[cmdTable].cmd do
				local isCmd = MultiOverlayV3.cmdTable[cmdTable].cmd[cmd];
				if isCmd.typ == "output_" then
					for slot=1, #mohSLOTs do
						local whichSubSLOT = mohSLOTs[slot][1];						
						if not isAlreadyExits(whichSubSLOT, isCmd.sortBy) then
							table.insert(moSetGetOverlays.slot[whichSubSLOT].setting.sortNames, isCmd.sortBy);
						end;												
					end;
				end;
			end;
		end;		
		function comp(w1,w2)			
			if w1 < w2 then
				return true;
			end;			
		end;
		for slot=1, #mohSLOTs do
			local whichSubSLOT = mohSLOTs[slot][1];			
			table.sort(moSetGetOverlays.slot[whichSubSLOT].setting.sortNames, comp);
			table.insert(moSetGetOverlays.slot[whichSubSLOT].setting.sortNames, 1, "All");			
		end;		
	end;	
	if update == nil or not update then
		buyingStationsSimple:generateCmd();
		fillTypesAmount:generateCmd();
		fillTypesAmountPrice:generateCmd();
		sellingStationsSimple:generateCmd();
		beehivehouses:generateCmd();
		heatingplants:generateCmd();
		solarcollectoren:generateCmd();
		windturbinen:generateCmd();
		animals:generateCmd();
		greenhouses:generateCmd();
		bgas:generateCmd();
		missions:generateCmd();
		bunkersilos:generateCmd();
		feedmixers:generateCmd();
		gcfactorys:generateCmd();
		setSlotSortCmdTable();		
	elseif update ~= nil and update then
		for cmd=2, #MultiOverlayV3.cmdTable[MultiOverlayV3.moduleCmdTable].cmd do			
			MultiOverlayV3.cmdTable[MultiOverlayV3.moduleCmdTable].cmd[cmd] = nil;			
		end;		
		moModule:slotOutputCmd();
	end;
end;

function moModule:generateCmd(update)
	if update ~= nil and update then return;end;
	local moduleCmdTable, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.ownCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "moduleUpdate";
		displayName = "Alle Module manuell Updaten";		
		multiple = false;
		sortBy = "Moh Speziale";
		infoTxt = "Gelöschte Objecte werden Automatisch entfernt.Neue kann man mit diesem Cmd dann in den Mod laden.Schont die Performens.All Module manual update (when you set a new object)";
		helpTxt = "All Module manual update (when you set a new object)";
		click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=false, key=false}; --left/middle/right MouseClick
		typ = "action";
		action = moModule.updateByPlayer; --a function
		ownValues = {};			 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate moModule Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
	--module
	newCmdTable = {	
	realName = tostring(MultiOverlayV3.metadata.title);
	guiMenue = false;	
	onOff = true;
	luaName = "multioverlayV3Module";
	cmdTable = {};	
	};
	--cmd 1--
	newCmdTable.cmdTable[1] = {
		cmdName = "fillTypesEnableDisable";
		displayName = "Enable/Disable FillTypes";		
		multiple = false;
		sortBy = "Speziale FillTypes";
		infoTxt = "Aktiviere/Deaktiviere die FillTypes die du angezeigt haben willst";
		helpTxt = "Enable/Disable FillTypes in List";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true};
		lineTyp = 1;
		typ = "output";
		action = fillTypesEnableDisable.giveOutputTable; --a function
		ownValues = {}; 
	};
	--cmd 1--
	moduleCmdTable, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	if moduleCmdTable ~= 0 then MultiOverlayV3.moduleCmdTable = moduleCmdTable;end;	
	errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->module cmd generate error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
	--module	
end;

local test = false;
function moModule:loadObjects()
	moModule.sellingStations = {};
	moModule.buyingStations = {};
	moModule.storages = {};
	moModule.bgas = {};
	moModule.bunkerSilos = {};
	moModule.greenhouses = {};
	moModule.gc = {factorys={}}; --GlobalCompany
	moModule.animals = {};
	moModule.beehivehouses = {};
	moModule.windturbinen = {};
	moModule.solarcollectoren = {};
	moModule.heatingplants = {};
	moModule.feedMixers = {}; --FeedMixer Script
	moModule.heapPreview = {}; --heapPreview --MaizePlus
	moModule.others = {};
	if g_currentMission.objectsToClassName == nil then return;end;
	for object, class in pairs(g_currentMission.objectsToClassName) do
		--print("g_currentMission.objectsToClassName object und class ...".. tostring(object).. "-----".. tostring(class))
		if class == "SellingStationPlaceable" then
			moModule.sellingStations[#moModule.sellingStations+1] = {};
			local station = moModule.sellingStations[#moModule.sellingStations];
			station.object = object;
			station.name = "Unknown"
			if object.sellingStation ~= nil then station.name = Utils.getNoNil(object.sellingStation.stationName, "Unknown");end;			
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module SellingStation configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					station.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					station.xmlName = "sellingStationXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if station.name == "Unknown" and storeItem.name ~= nil then	station.name = storeItem.name;end;
					station.storeData = storeItem;
				end;
			end;
			if station.name == "Unknown" then station.name = "SellingStation ".. tostring(#moModule.sellingStations);end;
			--print("objectName SellingStationPlaceable= ".. tostring(station.name));
		elseif class == "SiloExtensionPlaceable" or class == "SiloPlaceable" then	
			moModule.storages[#moModule.storages+1] = {};
			local storage = moModule.storages[#moModule.storages];
			storage.object = object;			
			storage.name = "Unknown";
			if object.unloadingStation ~= nil then storage.name = Utils.getNoNil(object.unloadingStation.stationName, "Unknown");end;
			if storage.name == "Unknown" and object.loadingStation ~= nil then storage.name = Utils.getNoNil(object.loadingStation.stationName, "Unknown");end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module Silo configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					storage.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					storage.xmlName = "storageXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if storage.name == "Unknown" and storeItem.name ~= nil then storage.name = storeItem.name;end;
					storage.storeData = storeItem;
				end;
			end;
			if storage.name == "Unknown" then storage.name = "Silo ".. tostring(#moModule.storages);end;
			--print("objectName SiloPlaceable+SiloExtensionPlaceable= ".. tostring(storage.name));
		elseif class == "GreenhousePlaceable" then 
			moModule.greenhouses[#moModule.greenhouses+1] = {};
			local greenhouse = moModule.greenhouses[#moModule.greenhouses];
			greenhouse.object = object;			
			greenhouse.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);			
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module Greenhouse configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					greenhouse.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					greenhouse.xmlName = "greenhouseXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if greenhouse.name == "Unknown" and storeItem.name ~= nil then greenhouse.name = storeItem.name;end;
					greenhouse.storeData = storeItem;
				end;
			end;
			if greenhouse.name == "Unknown" then greenhouse.name = "Greenhouse ".. tostring(#moModule.greenhouses);end;
			--print("objectName GreenhousePlaceable= ".. tostring(greenhouse.name));			
		elseif class == "BgaPlaceable" then	
			moModule.bgas[#moModule.bgas+1] = {};
			local bga = moModule.bgas[#moModule.bgas];
			bga.object = object;			
			bga.name = "Unknown";
			if object.bga ~= nil and object.bga.digestateSilo ~= nil and object.bga.digestateSilo.loadingStation ~= nil then bga.name = Utils.getNoNil(object.bga.digestateSilo.loadingStation.stationName, "Unknown");end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module Bga configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					bga.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					bga.xmlName = "bgaXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if bga.name == "Unknown" and storeItem.name ~= nil then bga.name = storeItem.name;end;
					bga.storeData = storeItem;
				end;
			end;
			if bga.name == "Unknown" then bga.name = "BGA ".. tostring(#moModule.bgas);end;
			--print("objectName BgaPlaceable= ".. tostring(bga.name));			
		elseif class == "BuyingStationPlaceable" then		
			moModule.buyingStations[#moModule.buyingStations+1] = {};
			local buyingStation = moModule.buyingStations[#moModule.buyingStations];
			buyingStation.object = object;			
			buyingStation.name = "Unknown";
			if object.buyingStation ~= nil then buyingStation.name = Utils.getNoNil(object.buyingStation.stationName, "Unknown");end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module BuyingStation configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					buyingStation.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					buyingStation.xmlName = "buyingStationXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if buyingStation.name == "Unknown" and storeItem.name ~= nil then buyingStation.name = storeItem.name;end;
					buyingStation.storeData = storeItem;
				end;
			end;
			if buyingStation.name == "waterFillTrigger" then buyingStation.name = moLanguageXml:getTxt("buyingwater", nil, "Waterhole");end;
			if buyingStation.name == "Unknown" then buyingStation.name = "BuyingStation ".. tostring(#moModule.buyingStation);end;
			--print("objectName BuyingStation= ".. tostring(buyingStation.name));
		elseif class == "BeehivePlaceable" then
			moModule.beehivehouses[#moModule.beehivehouses+1] = {};
			local beehivehouse = moModule.beehivehouses[#moModule.beehivehouses];
			beehivehouse.object = object;			
			beehivehouse.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module BeehiveHouse configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					beehivehouse.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					beehivehouse.xmlName = "beehivehouseXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if beehivehouse.name == "Unknown" and storeItem.name ~= nil then beehivehouse.name = storeItem.name;end;
					beehivehouse.storeData = storeItem;
				end;
			end;
			if beehivehouse.name == "Unknown" then beehivehouse.name = "Beehivehouse ".. tostring(#moModule.beehivehouses);end;
			--print("objectName BeehiveHouse= ".. tostring(beehivehouse.name));			
		elseif class == "WindTurbinePlaceable" then
			moModule.windturbinen[#moModule.windturbinen+1] = {};
			local windturbine = moModule.windturbinen[#moModule.windturbinen];
			windturbine.object = object;			
			windturbine.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module WindTurbine configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					windturbine.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					windturbine.xmlName = "windturbineXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if windturbine.name == "Unknown" and storeItem.name ~= nil then windturbine.name = storeItem.name;end;
					windturbine.storeData = storeItem;
				end;
			end;
			if windturbine.name == "Unknown" then windturbine.name = "WindTurbine ".. tostring(#moModule.windturbinen);end;
			--print("objectName WindTurbine= ".. tostring(windturbine.name));
		elseif class == "SolarCollectorPlaceable" then
			moModule.solarcollectoren[#moModule.solarcollectoren+1] = {};
			local solarcollector = moModule.solarcollectoren[#moModule.solarcollectoren];
			solarcollector.object = object;			
			solarcollector.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module SolarCollector configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					solarcollector.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					solarcollector.xmlName = "solarcollectorXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if solarcollector.name == "Unknown" and storeItem.name ~= nil then solarcollector.name = storeItem.name;end;
					solarcollector.storeData = storeItem;
				end;
			end;
			if solarcollector.name == "Unknown" then solarcollector.name = "SolarCollector ".. tostring(#moModule.solarcollectoren);end;
			--print("objectName SolarCollector= ".. tostring(solarcollector.name));
		elseif class == "HeatingPlantPlaceable" then
			moModule.heatingplants[#moModule.heatingplants+1] = {};
			local heatingplant = moModule.heatingplants[#moModule.heatingplants];
			heatingplant.object = object;			
			heatingplant.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module HeatingPlant configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					heatingplant.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					heatingplant.xmlName = "heatingplantXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if heatingplant.name == "Unknown" and storeItem.name ~= nil then heatingplant.name = storeItem.name;end;
					heatingplant.storeData = storeItem;
				end;
			end;
			if heatingplant.name == "Unknown" then heatingplant.name = "HeatingPlant ".. tostring(#moModule.heatingplants);end;
			--print("objectName HeatingPlant= ".. tostring(heatingplant.name));			
		elseif class == "AnimalHusbandry" then
			moModule.animals[#moModule.animals+1] = {};
			local animal = moModule.animals[#moModule.animals];
			animal.object = object;			
			animal.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module Animal configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					animal.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					animal.xmlName = "animalXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if animal.name == "Unknown" and storeItem.name ~= nil then animal.name = storeItem.name;end;
					animal.storeData = storeItem;
				end;
			end;
			if animal.name == "Unknown" then
				local animalModule = object:getModuleByName("animals");
				if animalModule ~= nil then		
					animal.name = tostring(animalModule:getAnimalType());					
				end;
			end;			
			if animal.name == "Unknown" then animal.name = "Animal ".. tostring(#moModule.animals);end;
			--print("objectName AnimalHusbandry= ".. tostring(animal.name));			
		elseif class == "BunkerSiloPlaceable" then	
			moModule.bunkerSilos[#moModule.bunkerSilos+1] = {};
			local bunkerSilo = moModule.bunkerSilos[#moModule.bunkerSilos];
			bunkerSilo.object = object;			
			bunkerSilo.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module BunkerSilo configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					bunkerSilo.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					bunkerSilo.xmlName = "bunkerSiloXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if bunkerSilo.name == "Unknown" and storeItem.name ~= nil then bunkerSilo.name = storeItem.name;end;
					bunkerSilo.storeData = storeItem;
				end;
			end;
			if bunkerSilo.name == "Unknown" then bunkerSilo.name = "Bunker Silo ".. tostring(#moModule.bunkerSilos);end;
			--print("objectName BunkerSiloPlaceable= ".. tostring(bunkerSilo.name));					
		elseif object.numInputs ~= nil and object.numOutputs ~= nil then
			moModule.feedMixers[#moModule.feedMixers+1] = {};
			local feedMixer = moModule.feedMixers[#moModule.feedMixers];
			feedMixer.object = object;			
			feedMixer.name = "Unknown";
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module FeedMixer configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					feedMixer.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					feedMixer.xmlName = "feedMixerXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if feedMixer.name == "Unknown" and storeItem.name ~= nil then feedMixer.name = storeItem.name;end;
					feedMixer.storeData = storeItem;
				end;
			end;
			if feedMixer.name == "Unknown" then feedMixer.name = "FeedMixer ".. tostring(#moModule.feedMixers);end;		
			--print("objectName FeedMixers= ".. tostring(feedMixer.name));		
		end;	
	end;
	local env = getfenv(0);		
	if env["FS19_GlobalCompany"] ~= nil then
		if env["FS19_GlobalCompany"]["GlobalCompany"] ~= nil then
			if env["FS19_GlobalCompany"]["GlobalCompany"].loadedFactories ~= nil and #env["FS19_GlobalCompany"]["GlobalCompany"].loadedFactories > 0 then
				for _, object in pairs(env["FS19_GlobalCompany"]["GlobalCompany"].loadedFactories) do
					moModule.gc.factorys[#moModule.gc.factorys+1] = {};
					local gcFactory = moModule.gc.factorys[#moModule.gc.factorys];
					gcFactory.object = object;			
					gcFactory.name = Utils.getNoNil(object.indexName, "Unknown");
					local xmlObject = Utils.getNoNil(object.xmlFilename, nil);
					if xmlObject ~= nil then
						local stringTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {xmlObject, "/"}, "Module GC Factory configFile XML/String Split");
						if isOkay then
							local xmlName = stringTable[#stringTable];
							gcFactory.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
						else
							gcFactory.xmlName = "gcFactoryXmlUnknown"; --needs for cmd
						end;
						local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
						if storeItem ~= nil then
							if gcFactory.name == "Unknown" and storeItem.name ~= nil then gcFactory.name = storeItem.name;end;
							gcFactory.storeData = storeItem;
						end;
					end;
					if gcFactory.name == "Unknown" then gcFactory.name = "GCFactory ".. tostring(#moModule.gc);end;		
					--print("objectName GCFactory= ".. tostring(gcFactory.name));					
				end;
			end;
		end;
		
		
		--for key, value in pairs(moModule.gc.factorys[1].object) do
		--	print("GCFactory key und value ...".. tostring(key).. "-----".. tostring(value))
		--	if key == "productLines" then
		--		for key1, value1 in pairs(value[1]) do
		--			print("productLines[1] key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
		--		end;				
		--	end;
		--end;
		--for key, value in pairs(env["FS19_GlobalCompany"]) do
		--	print("FS19_GlobalCompany key und value ...".. tostring(key).. "-----".. tostring(value))
		--	if key == "GlobalCompany" then
		--		for key1, value1 in pairs(value.loadedFactories) do
		--			print("GlobalCompany.loadedFactories table key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
		--		end;
		--	end;
		--end;
	end;
	function comp(w1,w2)			
		if w1.name < w2.name then
			return true;
		end;			
	end;	
	if #moModule.sellingStations > 1 then table.sort(moModule.sellingStations, comp);end;
	if #moModule.storages > 1 then table.sort(moModule.storages, comp);end;
	if #moModule.greenhouses > 1 then table.sort(moModule.greenhouses, comp);end;
	if #moModule.bgas > 1 then table.sort(moModule.bgas, comp);end;
	if #moModule.bunkerSilos > 1 then table.sort(moModule.bunkerSilos, comp);end;
	if #moModule.buyingStations > 1 then table.sort(moModule.buyingStations, comp);end;
	if #moModule.animals > 1 then table.sort(moModule.animals, comp);end;
	if #moModule.gc.factorys > 1 then table.sort(moModule.gc.factorys, comp);end;
	if #moModule.feedMixers > 1 then table.sort(moModule.feedMixers, comp);end;
	if #moModule.others > 1 then table.sort(moModule.others, comp);end;	
end;

function moModule:isObject(object, gc)
	--g_currentMission:getNodeObject(object)
	if gc then
		if object == nil or object.rootNode == 0 then return false;end;	
		local rootNode = getNumOfChildren(Utils.getNoNil(object.rootNode, 0));
		if rootNode == nil or rootNode == 0 then return false;end;return true;		
	else
		if object == nil or object.nodeId == 0 then return false;end;	
		local nodeId = getNumOfChildren(Utils.getNoNil(object.nodeId, 0));
		if nodeId == nil or nodeId == 0 then return false;end;return true;
	end;
end;

function moModule:nearPlayerPosition(object, distance, gc)		
	if moModule:isObject(object, gc) then
		local defaultDistance = distance or 5;
		function getPlayerPos()
			if g_currentMission.controlledVehicle ~= nil then
				if g_currentMission.controlledVehicle.steeringAxleNode ~= nil then
					return getWorldTranslation(g_currentMission.controlledVehicle.steeringAxleNode);
				end;
			else
				return g_currentMission.player:getPositionData();
			end;
			return nil;
		end;	
		local x, y, z = getPlayerPos();
		if x == nil then return false;end;
		local objectX, objectY, objectZ = nil, nil, nil;
		if gc then 
			objectX, objectY, objectZ = getWorldTranslation(object.rootNode);
		else
			objectX, objectY, objectZ = getWorldTranslation(object.nodeId);
		end;
		if objectX == nil or objectY == nil or objectZ == nil then return nil;end;
		local mathDistance = MathUtil.vector3Length(objectX-x, objectY-y, objectZ-z);	
		if mathDistance < defaultDistance then return true, x, y, z;else return false;end;	
	end;
	return nil;
end;

function moModule:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moAnimals.values == nil then moAnimalsConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.prozentColor(%d)"):format(0);
	for color=1, 7 do
		if getXMLString(Xml, groupNameTag.. "#color".. tostring(color)) ~= nil then
			moColors.prozent[color] = getXMLString(Xml, groupNameTag.. "#color".. tostring(color));
		end;
	end;
	groupNameTag = (xmlNameTag.. ".module.txt");
	if getXMLBool(Xml, groupNameTag.. "#bold") ~= nil then
		moModule.values.txtBold = getXMLBool(Xml, groupNameTag.. "#bold");
	end;
	if getXMLBool(Xml, groupNameTag.. "#languageXml") ~= nil then
		moModule.values.languageXml = getXMLBool(Xml, groupNameTag.. "#languageXml");
	end;
	if getXMLString(Xml, groupNameTag.. "#color") then
		moModule.values.txtColor = getXMLString(Xml, groupNameTag.. "#color");
	end;
	if getXMLString(Xml, groupNameTag.. "#titleColor") then
		moModule.values.txtTitleColor = getXMLString(Xml, groupNameTag.. "#titleColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#activeColor") then
		moModule.values.txtActiveColor = getXMLString(Xml, groupNameTag.. "#activeColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#greatDemandColor") then
		moModule.values.txtGreatDemandColor = getXMLString(Xml, groupNameTag.. "#greatDemandColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#fillTypesColor") then
		moModule.values.txtFillTypesColor = getXMLString(Xml, groupNameTag.. "#fillTypesColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#noAmountColor") then
		moModule.values.txtNoAmountColor = getXMLString(Xml, groupNameTag.. "#noAmountColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#amountColor") then
		moModule.values.txtAmountColor = getXMLString(Xml, groupNameTag.. "#amountColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#priceColor") then
		moModule.values.txtPriceColor = getXMLString(Xml, groupNameTag.. "#priceColor");
	end;
	if getXMLString(Xml, groupNameTag.. "#noPriceColor") then
		moModule.values.txtNoPriceColor = getXMLString(Xml, groupNameTag.. "#noPriceColor");
	end;
end;

function moModule:saveXml(self, Xml, xmlNameTag)	
	local groupNameTag = (xmlNameTag.. ".module.prozentColor(%d)"):format(0);	
	for color=1, #moColors.prozent do
		setXMLString(Xml, groupNameTag.. "#color".. tostring(color), moColors.prozent[color]);
	end;
	groupNameTag = (xmlNameTag.. ".module.txt(%d)"):format(0);		
	setXMLBool(Xml, groupNameTag.. "#bold", moModule.values.txtBold);	
	setXMLString(Xml, groupNameTag.. "#color", moModule.values.txtColor);	
	setXMLString(Xml, groupNameTag.. "#titleColor", moModule.values.txtTitleColor);
	setXMLString(Xml, groupNameTag.. "#activeColor", moModule.values.txtActiveColor);
	setXMLString(Xml, groupNameTag.. "#greatDemandColor", moModule.values.txtGreatDemandColor);
	setXMLString(Xml, groupNameTag.. "#fillTypesColor", moModule.values.txtFillTypesColor);
	setXMLString(Xml, groupNameTag.. "#amountColor", moModule.values.txtAmountColor);
	setXMLString(Xml, groupNameTag.. "#noAmountColor", moModule.values.txtNoAmountColor);
	setXMLString(Xml, groupNameTag.. "#priceColor", moModule.values.txtPriceColor);
	setXMLString(Xml, groupNameTag.. "#noPriceColor", moModule.values.txtNoPriceColor);
	setXMLBool(Xml, groupNameTag.. "#languageXml", moModule.values.languageXml);
end;

    